/**
 * This file used to login user into web page If the user is third party user.
 * This will reuse vtc3pman javascript SDK This javascript needs jquery
 */
// This function used to convert a.b.c.d version to a number.
// Let's just take it as a*1000000 + b*10000 + c*100 + d
var vtcPlugin = function(id) {
	return document.getElementById(id);
};
var gObject;
var timerP;
var timerP_2;
var convToNum = function(ver) {
	var num = 0;
	if (typeof ver != "undefined") {
		var vers = ver.split(".");
		var index;
		for (index = 0; index < vers.length; index++) {
			num = num * 100;
			num = num + Math.round(vers[index]);
		}
	}
	return num;
};

function vtcman() {
	if (typeof vtc3pman == "undefined") {
		alert("vtc3p.min.js not included");
	}
	// include the vtc3pman login functions.
	// this.loginPath = "ajx/userLogin.do";
	this.logoutPath = "ajx/userLogout.do";
	this.p = new vtc3pman();
	this.check();
};

vtcman.prototype.check = function() {
	this.p.check();
};
vtcman.prototype.setDomain = function(host, port) {
	this.p.setDomain(host, port);
};

// This function takes thirdId and password.
vtcman.prototype.login = function(appId, thirdId, pass, success, fail) {
	this.p.login(appId, thirdId, pass, success, fail);
};

// logout
vtcman.prototype.logout = function() {
	var portStr = "";
	if (this.p.port != 80) {
		portStr = ":" + this.p.port;
	}
	var url = "http://" + this.p.domain + portStr + "/" + this.p.context + "/"
			+ this.logoutPath;
//	 var url = "http://" + "www.vtc365.cn" + ":8080" + "/" + this.p.context +
//	 "/"
//	 + this.logoutPath;
	var data = "callback=?";
	$.ajax({
		url : url,
		data : data,
		type : "POST",
		dataType : "jsonp",
		success : function(res) {
			if (typeof res == "object") {
				var result = res.result;
				if (result == "OK") {
					// The web site succeed
					if (typeof success == "string") {
						var host = window.location.hostname;
						vtcRemoveInfo("mypass@" + host);
						top.location.href = this.logoutPat;
					}
				} else {
					if (typeof fail == "function") {
						fail(result);
					}
				}
			} else {
				if (typeof fail == "function") {
					fail("failed");
				}
			}
		},
		error : function(jqxhr, status, e) {
			if (typeof fail == "function") {
				fail(e);
			}
		}
	});
};

// To create a vtcvideo object.
// It takes a div object.(Jquery obj)
function vtcvideo(obj) {
	this.p = new vtc3pman();
	this.check();
	if (typeof obj != undefined) {
		this.divbox = obj;
	} else {
		alert("Need a html box!");
	}
	this.maxversion = "0.0.5.2";
	this.minversion = "0.0.5.2";
	this.maxvernum = convToNum(this.maxversion);
	this.minvernum = convToNum(this.minversion);
	this.winpluginname = "vtc365.vtcWebPlugin";
	this.othername = "VTC Web Plugin";
	this.audio_sr = 44100;
	this.objCreated = false;
	PLUGINVERSION = "0.0.5.2";
	
	// Check if the plugin is installed.
	if (!this.checkPlugin()) {
		content = "<div style= text-align:center;vertical-align:middle><font color='red'>"
			+ "插件没有安装,请点击<a href='./resource/VTCWebPlugin_"
			+ PLUGINVERSION
			+ ".msi'>下载</a>并安装插件,请完成后重启浏览器</font></div>";
		this.divbox.html(content);
		window.noPlugin = true;
	} else{
		window.noPlugin = false;
	}
	
};

vtcvideo.prototype.check = function() {
	this.p.check();
};
vtcvideo.prototype.setDomain = function(host, port) {
	this.p.setDomain(host, port);
};

// Check if the vtc plugin is ready.
vtcvideo.prototype.checkPlugin = function() {
	var np = navigator.plugins;
	var haveplugin, newplugin, pluginuseable;
	// firefox, chrome
	var cv;
	if (np && np.length) {
		for (var i = 0; i < np.length; i++) {
			if (np[i].name == this.othername) {
				cv = np[i].description.split(" ");
				cv = cv[cv.length - 1];
				if (!cv.match(/([\d.])+/))
					cv = "0";
			}
		}
	} else if (window.ActiveXObject) {
		try {
			var axobj = new ActiveXObject(this.winpluginname);
			if (axobj)
				cv = axobj.version || "0";
		} catch (e) {
		}
	}
	this.version = cv;
	this.vernum = convToNum(cv);
	return (this.vernum <= this.maxvernum && this.vernum >= this.minvernum);

};

// vtcvideo.prototype.timedplay = function (){
// setTimeout(function(){autoplay();}, 3000);
// };

// create a specific tag
vtcvideo.prototype.createTag = function(tagname, name, value, id) {
	var obj = $("<" + tagname + "/>");
	obj.attr("name", name).attr("value", value).attr("id", id + name);
	return obj;
};
// To get list of the devices.
vtcvideo.prototype.getDevList = function() {
	if (this.objbox == undefined) {
		this.createObj();
	}
	if (this.playerobj != undefined) {
		// The object is created.
		var obj = this.playerobj;
		if (obj != undefined && typeof (obj.getVideoDevList) == "function") {
			var devlist = obj.getVideoDevList();
			if (devlist != undefined) {
				return devlist.split("|");
			}
		}
	} else {
		return [];
	}
};
// To get the all color sapces of camera
vtcvideo.prototype.getColorSpaces = function(d) {
	if (this.objbox == undefined) {
		this.createObj();
	}
	var devlist = [];
	if (d != undefined) {
		devlist = d;
	} else {
		devlist = this.devList;
	}
	var colorSpaces = [];
	if (this.objbox != undefined) {
		var obj = this.objbox[0];
		if (obj != undefined && typeof (obj.findColorSpaces) == "function") {
			for ( var i in devlist) {
				var spaces = obj.findColorSpaces(devlist[i]);
				if (spaces != undefined) {
					colorSpaces = colorSpaces.concat(spaces.split("|"));
				}
			}
		}
	}
	return colorSpaces;
};
// To get all resoutions (device and colorspace)
vtcvideo.prototype.getResolutions = function(d, s) {
	if (this.objbox == undefined) {
		this.createObj();
	}
	var spaces = [];
	if (s != undefined) {
		spaces = s;
	} else {
		// To get all colorspaces;
		spaces = this.getColorSpaces(d);
	}
	var resolutions = [];
	if (this.objbox != undefined) {
		var obj = this.objbox[0];
		if (obj != undefined && typeof (obj.findResolutions) == "function") {
			for ( var i in spaces) {
				var reses = obj.findResolutions(d[0], spaces[i]);
				if (reses != undefined) {
					resolutions = resolutions.concat(reses.split("|"));
				}
			}
		}
	}
	return resolutions;
};
// to choose the default device and resolutions.
// This used to create the object of vtc web live plugin in the divbox.
vtcvideo.prototype.createObj = function(fps, dev, preset, tune, other) {
	if (typeof this.divbox != "undefined") {
		if (fps == undefined) {
			fps = 25;
		}
		if (preset == undefined) {
			preset = "faster";
		}
		if (tune == undefined) {
			tune = "zerolatency";
		}
		if (other == undefined) {
			other = "";
		}
		var objbox;
		if (this.objectId != undefined) {
			objbox = $("#" + this.objectId);
		} else {
			this.objectId = "VTC" + new Date().getTime();
		}
		if (typeof objbox == "undefined") {
			objbox = $("<object>");
			this.objectId = "VTC" + (new Date()).getTime();
			objbox.attr("id", this.objectId).attr("type",
					"application/x-vtcwebplugin1");
			objbox.width(this.divbox.width());
			objbox.height(this.divbox.height());
			objbox.append(this.createTag("param", "width", this.divbox.width(),
					this.objectId));
			objbox.append(this.createTag("param", "height", this.divbox
					.height(), this.objectId));
			objbox.append(this.createTag("param", "action",
					"capture_audio_video", this.objectId));
			if (dev == undefined) {
				dev = "";
			}
			objbox.append(this.createTag("param", "video_capture_dev", dev,
					this.objectId));
			objbox.append(this.createTag("param", "video_fps", fps,
					this.objectId));
			objbox.append(this.createTag("param", "video_preset", preset,
					this.objectId));
			objbox.append(this.createTag("param", "video_tune", tune,
					this.objectId));
			objbox.append(this.createTag("param", "video_other_options", other,
					this.objectId));
			objbox.append(this.createTag("param", "autoplay", "false",
					this.objectId));
			this.objbox = objbox;
			if (typeof this.objCreated == true) {
				this.divbox.empty(objbox);
			}
			this.divbox.append(objbox);
			this.playerobj = vtcPlugin(this.objectId);
			this.objCreated = true;
		}
	}
};

// To get the child tag of object param
vtcvideo.prototype.getChildParam = function(obj, name) {
	if (obj != undefined && name != undefined) {
		var tag = $("#" + this.objectId + name);
		if (tag.length > 0) {
			return tag;
		}
	}
	return undefined;
};
// to replace the existing video_capture_dev param of the objbox
vtcvideo.prototype.replaceNameValue = function(name, value) {
	if (name != undefined && this.objbox != undefined) {
		var tag = this.getChildParam(this.objbox, name);
		if (tag != undefined) {
			tag.attr("value", value);
		} else {
			tag = this.createTag("param", name, value, this.objectId);
			if (tag) {
				this.objbox.append(tag);
			}
		}
	}
};

// Start the video with resolution and device
// The url is rtp address, in format like "rtp://ip:port"

vtcvideo.prototype.startVideo = function(dev, resolution, url) {
	
	if (this.started) {
		this.stopVideo();
	}
	if (this.objbox == undefined) {
		this.createObj();
	}
	this.replaceNameValue("video_capture_dev", dev);
	var tag = this.getChildParam(this.objbox, "video_capture_dev");
	if (tag == undefined) {
		// Unable to start a video since there is no dev. So, let's get a
		// default dev.
		var ndevs = this.getDevList();
		if (ndevs.length > 0) {
			this.replaceNameValue("video_capture_dev", ndevs[0]);
		} else {
			alert("No suitable camera found");
		}
	}
	var dims = resolution.split("x");
	if (dims.length == 2) {
		this.replaceNameValue("width", dims[0]);
		this.replaceNameValue("height", dims[1]);
	}
	
	if (this.objbox[0].initCapture(this.audio_sr) == 0) {
	
	this.objbox[0].startCapture(url);
	this.started = true;

	// 给server发送心跳，5秒一次
	var postSeq = 0;
	var seq = 0;
	this.liveHeartBeat = "ajx/liveHeartBeat.do";
	var portStr = "";
	if (this.p.port != 80) {
		portStr = ":" + this.p.port;
	}
	var url = "http://" + this.p.domain + portStr + "/" + this.p.context + "/"
			+ this.liveHeartBeat;

//	 var url = "http://" + "www.vtc365.cn" + ":8080" + "/" + this.p.context +
//	 "/"
//	 + this.liveHeartBeat;

	timerP_2 = window.setTimeout(function() {
		postSeq++;
		seq++;
		$.ajax({
			url : url,
			type : "POST",
			dataType : "jsonp",
			success : function(rs) {
			}
		});
		timerP_2 = setTimeout(arguments.callee, 5000);
	}, 5000);
	
	var index = 0;
	title = document.title;
	timerP = window.setTimeout(function() {
		index++;
		if (index == 3) {
			index = 1;
		}
		if (index == 1) {
			document.title = title;
		}
		if (index == 2) {
			document.title = "【正在直播】" + title;
		}
		timerP = setTimeout(arguments.callee, 500);
	}, 500);
	gObject = this.objbox;
	
	} else {
		content = "<div style= text-align:center;vertical-align:middle><font color='red'>只能发起一个直播</font></div>";
		this.divbox.html(content);
		return;
	}
};
// To stop the video
vtcvideo.prototype.stopVideo = function() {
	if (this.started) {
		if (this.objbox.length > 0) {
			this.objbox[0].stopCapture();
			this.objbox[0].deinitCapture();
		}		
	} else {
		if(gObject != undefined){
			gObject[0].stopCapture();
			gObject[0].deinitCapture();
		}
	}
	if (this.divbox != undefined) {
		this.divbox.empty();
	}
	this.objbox = undefined;
	this.started = false;
	this.objCreated = false;
	window.clearTimeout(timerP);
	window.clearTimeout(timerP_2);
	document.title = title;
};

// check the dependency of javascript
vtcvideo.prototype.checkDep = function() {
	if (typeof jQuery != 'function') {
		alert("Jquery not found!");
	}
	if (typeof vtcStore != 'function') {
		alert("vtcutil.js not found");
	}
	if (typeof btoa != 'function') {
		alert("base64.js not found");
	}
};

vtcvideo.prototype.createPlayObj = function() {
	if (typeof this.divbox != "undefined") {
		var objbox;
		if (this.objectId != undefined) {
			objbox = $("#" + this.objectId);
		} else {
			this.objectId = "VTC" + new Date().getTime();
		}
		if (typeof objbox == "undefined") {
			objbox = $("<object>");
			this.objectId = "VTC" + (new Date()).getTime();
			objbox.attr("id", this.objectId).attr("type",
					"application/x-vtcwebplugin1");
			objbox.width(this.divbox.width());
			objbox.height(this.divbox.height());
			objbox.append(this.createTag("param", "width", this.divbox.width(),
					this.objectId));
			objbox.append(this.createTag("param", "height", this.divbox
					.height(), this.objectId));
			objbox.append(this.createTag("param", "action", "play",
					this.objectId));
			objbox.append(this.createTag("param", "autoplay", "false",
					this.objectId));
			this.objbox = objbox;
			if (typeof this.objCreated == true) {
				this.divbox.empty(objbox);
			}
			this.divbox.append(objbox);
			this.playerobj = vtcPlugin(this.objectId);
			this.objCreated = true;
		}
	}
};

// check if the Flash is ready
vtcvideo.prototype.check_object = function(win_name, other_name) {
	var np = navigator.plugins;
	// firefox, chrome
	if (np && np.length) {
		for (var i = 0; i < np.length; i++) {
			if (np[i].name == other_name) {
				return true;
			}
		}
		return false;
	} else if (window.ActiveXObject) {
		try {
			var axobj = new ActiveXObject(win_name);
			return axobj != null;
		} catch (e) {
			return false;
		}
	} else {
		// 以上情况都排除则返回false
		return false;
	}
};

// Play with Plugin for the live video
vtcvideo.prototype.playWithPlugin = function(rtspUrl) {
	var rtsp = rtspUrl;

	if (window.noPlugin) {
		return;
	}
	if (this.objbox == undefined) {
		this.createPlayObj();
	}
	var vlcplayer = this.playerobj;
	if (vlcplayer) {
		vlcplayer.play(rtsp);
		// 需要再考虑，可以参数形式 让客户传递处理
		registerEvent(vlcplayer, 'MediaPlayerEndReached', function() {
			// 如果直播停止，该怎么处理？？？
			content = "<div style= text-align:center;vertical-align:middle><font color='red'>直播已结束</font></div>";
			this.divbox.html(content);
//			alert("直播已结束!");
			this.divbox.empty(objbox);
		});
		return vlcplayer;
	}
};

// Play with Flase for the m3u8 video on PC browse
vtcvideo.prototype.playWithFlash = function(url, videoId) {
	var streamURL = url;
	var vid = videoId;
	var currentStatus = 1;
	
	var width = this.divbox.width();
	var height = this.divbox.height();	
	jwplayer_video = "<div id='player" + vid
			+ "' class='playerBox'>缓冲中, 请稍等...</div>";
	
	if (this.check_object("ShockwaveFlash.ShockwaveFlash", "Shockwave Flash")) {
		var jprovider = "./tools/AdaptiveProvider.swf";
		this.divbox.html(jwplayer_video);
		var viewer = jwplayer("player" + vid);
		viewer.setup({
			width : width,
			height : height,
			flashplayer : './tools/player.swf',
			provider : jprovider,
			file : streamURL,
			stretching : 'exactfit',
			volume : 100,
			skin : './style/skin/snel/snel.xml',
			plugins : {
				'./js/jwlivestatus.js' : {}
			},
			events : {
				onError : function(event) {
					alert(event.message);
				},
				onReady : function(event) {
				}
			}
		});
		if (currentStatus === undefined) {
			viewer.play();
		} else if (currentStatus == 1) {
			viewer.play(true);
		} else if (currentStatus == 2) {
			viewer.play(false);
			viewer.pause(true);
		} else {
			viewer.play(true);
		}
	} else {
		var downloadurl = "http://www.adobe.com/go/getflashplayer/";
		var info = "<p><p><font color='red'>清晰版首次播放未检测到FLASH插件,请点击<a href='"
				+ downloadurl + "'>下载</a>并安装插件,请完成后重启浏览器</font>";
		// player[0].innerHTML=info;
		this.divbox.html(info);
	}
};

// Play with HTML5 for the m3u8 video on mobile browse, and both m3u8 and MP4
// video on PC browse
vtcvideo.prototype.playWithHTML5 = function(url, videoId) {
	var streamURL = url;
	var vid = videoId;
	jwplayer_video = "<div id='player" + vid
			+ "' class='playerBox'>缓冲中, 请稍等...</div>";
	this.divbox.html(jwplayer_video);
	
	var n = streamURL.lastIndexOf("/");
	var img = streamURL.substr(0, n) + "/0.jpg";
	var new_video = '<video width="540" height="400" src="' + streamURL
			+ '" autoplay="autoplay" controls poster="' + img
			+ '" id="h5vplayer' + vid + '"></video>';
	$("#player" + vid).replaceWith(new_video);
	$("#h5vplayer" + vid).show();
};

vtcvideo.prototype.videoPlay = function(videoID, playUrl, rtspURL, liveFlag) {
	var vid = videoID;
	var streamURL = playUrl;
	var rtsp = rtspURL;
	var liveF = liveFlag;
	
    if(rtsp=="" && streamURL=="")
    {
        alert("播放的视频不存在！");
        return;
    }
    
	var isRtpsUrl = rtspURL.indexOf("rtsp"); // 如果是以rtsp开头则返回0
	var ua = navigator.userAgent.toLowerCase();

	if (liveFlag == 1 && isRtpsUrl == 0) {
		// 直播视频
		// 判断是否是PC浏览器
		if (ua.match(/ipad/i) == "ipad"
				|| ua.match(/iphone os/i) == "iphone os"
				|| ua.match(/mobile/i) == "mobile") {
			// 手机浏览器
			// 判断VideoType
			if ((streamURL.length > 4 && streamURL.substring(
					streamURL.length - 4, streamURL.length).toLowerCase() == ".mp4")
					|| (streamURL.length > 5 && streamURL.substring(
							streamURL.length - 5, streamURL.length)
							.toLowerCase() == ".m3u8")) {
				// 手机浏览器 mp4和m3u8视频都以HMLT5播放
				this.playWithHTML5(streamURL, vid);
			} else {
				content1 = "<div style= text-align:center;vertical-align:middle><font color='red'>不支持此类型视频播放</font></div>";
				this.divbox.html(content1);
				return;
			}
		} else {
			// PC浏览器
			this.playWithPlugin(rtsp);
		}
	} else {
		// 非直播视频，判断VideoType
		if (streamURL.length > 5
				&& streamURL.substring(streamURL.length - 5, streamURL.length)
						.toLowerCase() == ".m3u8") {
			// m3u8格式视频PC浏览器使用Flash播放，手机视频使用HTML5播放
			if (ua.match(/ipad/i) == "ipad"
					|| ua.match(/iphone os/i) == "iphone os"
					|| ua.match(/mobile/i) == "mobile") {
				// 手机浏览器，HTML5播放
				this.playWithHTML5(streamURL, vid);
			} else {
				// PC浏览器，Flash播放
				this.playWithFlash(streamURL, vid);
			}
		} else if (streamURL.length > 5
				&& streamURL.substring(streamURL.length - 4, streamURL.length)
						.toLowerCase() == ".mp4") {
			// mp4格式视频 HTML5播放
			this.playWithHTML5(streamURL, vid);
		} else {
			content2 = "<div style= text-align:center;vertical-align:middle><font color='red'>不支持此类型视频播放</font></div>";
			this.divbox.html(content2);
			return;
		}
	}
};


//web related operation.
function vtcvideoweb() {
	this.startVideoUrl = "ajx/liveStartVideo.do";
	this.stopVideoUrl = "ajx/liveStopVideo.do";
	this.p = new vtc3pman();
};
vtcvideoweb.prototype.setDomain = function(host, port) {
	this.p.setDomain(host, port);
};

vtcvideoweb.prototype.setVideo = function(video) {
	this.video = video;
};



//start video
//success callback will take 3 parameters: vid, rtphost, rtpport, rtspurl,
//m3u8url

vtcvideoweb.prototype.start = function(success, fail, title, description, save,
		calltype, shareModel, content) {

	if (window.noPlugin) {
		return;
	}
	var portStr = "";
	if (this.p.port != 80) {
		portStr = ":" + this.p.port;
	}

	if (!title) {
		title = "";
	}
	if (!description) {
		description = "";
	}
	if (!calltype) {
		calltype = "";
	}
	if (!content) {
		content = 3;
	}
	if (save) {
		save = true;
	} else {
		save = false;
	}

	var url = "http://" + this.p.domain + portStr + "/" + this.p.context + "/"
			+ this.startVideoUrl;

//	 var url = "http://" + "www.vtc365.cn" + ":8080" + "/" + this.p.context +
//	 "/"
//	 + this.startVideoUrl;

	var data = "title=" + title + "&description=" + description + "&saveFlag="
			+ save + "&calltype=" + calltype + "&shareModel=" + shareModel + "&content=" + content
			+ "&callback=?";
	$
			.ajax({
				url : url,
				data : data,
				type : "POST",
				dataType : "jsonp",
				success : function(res) {
					if (typeof res == "object") {
						var result = res.result;
						if (result == "OK") {
							// The web site succeed
							if (typeof success == "function") {
								success(res.video.videoId, res.live.host,
										res.live.port, res.video.rtspURL,
										res.video.URL);
							}
						} else {
							if (typeof fail == "function") {
								fail(result);
							}
						}
					} else {
						if (typeof fail == "function") {
							fail("failed");
						}
					}
				},
				error : function(jqxhr, status, e) {
					if (typeof fail == "function") {
						fail(e);
					}
				}
			});
};
//To stop video.
//success callback take no parameter, fail takes error message as parameter.
vtcvideoweb.prototype.stop = function(success, fail) {
	
	var portStr = "";
	if (this.p.port != 80) {
		portStr = ":" + this.p.port;
	}

	var url = "http://" + this.p.domain + portStr + "/" + this.p.context + "/"
			+ this.stopVideoUrl;

//	 var url = "http://" + "www.vtc365.cn" + ":8080" + "/" + this.p.context +
//	 "/"
//	 + this.stopVideoUrl;

	var data = "callback=?";
	$.ajax({
		url : url,
		data : data,
		type : "POST",
		dataType : "jsonp",
		success : function(res) {
			if (typeof res == "object") {
				var result = res.result;
				if (result == "OK") {
					// The web site succeed
					if (typeof success == "function") {
						success();
					}
				} else {
					if (typeof fail == "function") {
						fail(result);
					}
				}
			} else {
				if (typeof fail == "function") {
					fail("failed");
				}
			}
		},
		error : function(jqxhr, status, e) {
			if (typeof fail == "function") {
				fail(e);
			}
		}
	});
};